# This is a verification script for the alphabetafilter generated code.
# Run this code in order to create a verification model with a CFunction block inside that behaves like the original model.

# CFunction variables
output_code = """
alphabetafilter_U.processNoiseVariance = input1;
alphabetafilter_U.measurementNoiseVariance = input2;
alphabetafilter_U.y = input3;
alphabetafilter_step();
output1 = alphabetafilter_Y.x;
"""
start_code = "alphabetafilter_init();"
terminate_code = "alphabetafilter_term();"

# Close
try engee.close("alphabetafilter_verification";force=true) catch end
# Create
engee.create("alphabetafilter_verification")
# Add Blocks
engee.add_block("/Basic/Ports & Subsystems/In1", "alphabetafilter_verification/")
engee.add_block("/Basic/Ports & Subsystems/In1", "alphabetafilter_verification/")
engee.add_block("/Basic/Ports & Subsystems/In1", "alphabetafilter_verification/")
engee.add_block("/Basic/User-Defined Functions/C Function", "alphabetafilter_verification/")
engee.add_block("/Basic/Ports & Subsystems/Out1", "alphabetafilter_verification/")
# Edit block parameters
engee.set_param!("alphabetafilter_verification/In1", "PortDimensions" => "1")
engee.set_param!("alphabetafilter_verification/In2", "PortDimensions" => "1")
engee.set_param!("alphabetafilter_verification/In3", "PortDimensions" => "1")
engee.set_param!("alphabetafilter_verification/C Function", "OutputCode" => output_code, "StartCode" => start_code, "TerminateCode" => terminate_code)
engee.set_param!("alphabetafilter_verification/C Function", "Inputs" => 3)
engee.set_param!("alphabetafilter_verification/C Function", "Outputs" => 1)
engee.set_param!("alphabetafilter_verification/C Function", "InputPort1Type" => "double")
engee.set_param!("alphabetafilter_verification/C Function", "InputPort1Size" => "1")
engee.set_param!("alphabetafilter_verification/C Function", "InputPort2Type" => "double")
engee.set_param!("alphabetafilter_verification/C Function", "InputPort2Size" => "1")
engee.set_param!("alphabetafilter_verification/C Function", "InputPort3Type" => "double")
engee.set_param!("alphabetafilter_verification/C Function", "InputPort3Size" => "1")
engee.set_param!("alphabetafilter_verification/C Function", "SampleTime" => "0.01")
engee.set_param!("alphabetafilter_verification/C Function", "OutputPort1Type" => "double")
engee.set_param!("alphabetafilter_verification/C Function", "OutputPort1Size" => "1")
engee.set_param!("alphabetafilter_verification/C Function", "SourceFiles" => "/user/start/examples/base_simulation/ccodeintegration/cg/engee/alphabetafilter_cg/alphabetafilter.c")
engee.set_param!("alphabetafilter_verification/C Function", "IncludeDirectories" => "/user/start/examples/base_simulation/ccodeintegration/cg/engee/alphabetafilter_cg/")
engee.set_param!("alphabetafilter_verification/C Function", "Headers" => "stdint.h math.h alphabetafilter.h")
# Edit model parameters
engee.set_param!("alphabetafilter_verification", "FixedStep" => 0.01)
engee.set_param!("alphabetafilter_verification", "StartTime" => 0.0)
engee.set_param!("alphabetafilter_verification", "StopTime" => 10)
engee.set_param!("alphabetafilter_verification", "EnableMultiTasking" => false)
# Add lines
engee.add_line("In1/1", "C Function/1")
engee.add_line("In2/1", "C Function/2")
engee.add_line("In3/1", "C Function/3")
engee.add_line("C Function/1", "Out1/1")
# Save
engee.save("alphabetafilter_verification.engee"; force=true)
